%define _prefix		/usr
%define _with_doc	0

%define name OpenSceneGraph
%define libname %mklibname %name
%define develname %mklibname %name -d
%define version	3.2.0
%define release	%mkrel 2

Name:			%{name}
Version:		%{version}
Release:		%{release}
URL:			http://www.openscenegraph.org/projects/osg
Summary:		Open source high performance 3D graphics toolkit
License:		OpenSceneGraph Public License
BuildRoot:		%{_tmppath}/%{name}-%{version}-build
Group:			Graphics
Source:			http://www.openscenegraph.org/downloads/developer_releases/%{name}-%{version}.tar.xz
Source1:		%{name}.png
Source90:		%{name}-rpmlintrc
Patch0:			OpenSceneGraph-2.8.3-ffmpeg.patch
BuildRequires:	cmake ccache
BuildRequires:	curl-devel
BuildRequires:	freetype2-devel
BuildRequires:	%{_lib}freeglut-devel
BuildRequires:	gcc-c++
BuildRequires:	%{_lib}gif-devel
# gif-devel instead of: {_lib}ungif-devel
BuildRequires:	gtkglext-devel
%if "%{_with_doc}" == "1"
BuildRequires:	doxygen
BuildRequires:	graphviz
%endif
BuildRequires:	%{_lib}jpeg-devel
BuildRequires:	%{_lib}png-devel
BuildRequires:	%{_lib}poppler-glib-devel
BuildRequires:	%{_lib}rsvg2-devel
BuildRequires:	%{_lib}tiff-devel
BuildRequires:	%{_lib}xine-devel
#BuildRequires:	%{_lib}xulrunner-devel
BuildRequires:	%{_lib}qt4-devel
BuildRequires:	%{_lib}SDL-devel
BuildRequires:	unzip
BuildRequires:	desktop-file-utils
BuildRequires:	%{_lib}wxgtk2.8-devel
BuildRequires:	zlib1-devel
BuildRequires:	%{_lib}oil-devel  %{_lib}sndfile-devel

%description
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

%package -n %{libname}
Summary:	Shared libraries for OpenSceneGraph
Group:		System/Libraries

%description -n %{libname}
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the shared libraries for OpenSceneGraph.

%package -n %{develname}
Summary:	OpenSceneGraph development files
Group:		Development/Libraries
Requires:	%{_lib}OpenSceneGraph = %{version}
Requires:	%{_lib}OpenThreads-devel = %{version}
Requires:	curl-devel
Requires:	freetype2-devel
Requires:	%{_lib}freeglut-devel
Requires:	%{_lib}ungif-devel
Requires:	%{_lib}gif-devel
# gif-devel instead of: {_lib}ungif-devel
Requires:	%{_lib}gtkglext-devel
Requires:	%{_lib}jpeg-devel
Requires:	%{_lib}png-devel
Requires:	%{_lib}poppler-glib-devel
Requires:	%{_lib}rsvg2-devel
Requires:	%{_lib}tiff-devel
Requires:	%{_lib}xine-devel
Requires:	%{_lib}qt4-devel
Requires:	%{_lib}SDL-devel

%description -n %{develname}
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the header and development files for
OpenSceneGraph.

%package -n %{_lib}OpenThreads
Summary:	Shared libraries for OpenSceneGraph
Group:		System/Libraries


%description -n %{_lib}OpenThreads
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the shared libraries for OpenSceneGraph.

%package -n %{_lib}OpenThreads-devel
Summary:	OpenSceneGraph development files
Group:		Development/Libraries
Requires:	%{_lib}OpenThreads = %{version}
Requires:	curl-devel
Requires:	freetype2-devel
Requires:	%{_lib}freeglut-devel
Requires:	%{_lib}gif-devel
# gif-devel instead of: {_lib}ungif-devel
Requires:	%{_lib}jpeg-devel
Requires:	%{_lib}poppler-glib-devel
Requires:	%{_lib}png-devel
Requires:	%{_lib}tiff-devel
Requires:	%{_lib}xine-devel
Requires:	%{_lib}qt4-devel
Requires:	%{_lib}SDL-devel

%description -n %{_lib}OpenThreads-devel
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the header and development files for
OpenSceneGraph.

%package plugins
Summary:	Plugins for OpenSceneGraph
Group:		Graphics

%description plugins
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains some plugins for OpenSceneGraph.

%package examples
Summary:	Example appliations for OpenSceneGraph
Group:		Graphics

%description examples
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains some example applications for OpenSceneGraph.


%prep
%setup -q -D -n %{name}-%{version}
%patch0 -p0

%if 0
%__sed -i -e 's|xulrunner-xpcom|libxul|g' \
	CMakeModules/FindXUL.cmake
%__sed -i -e 's|xulrunner-js|mozilla-js|g' \
	CMakeModules/FindXUL.cmake
%__sed -i -e 's|xulrunner-nspr|nspr|g' \
	CMakeModules/FindXUL.cmake
%__sed -i -e 's|xulrunner-nss|nss|g' \
	CMakeModules/FindXUL.cmake
%endif

%build
# Enable cccache
export CC="ccache gcc"
export CXX="ccache g++"

# Expand ccache
ccache -M 1G

export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
cmake \
	-DCMAKE_INSTALL_PREFIX=%{buildroot}%{_prefix} \
	-DBUILD_OSG_EXAMPLES=OFF \
	-DBUILD_OSG_PLUGINS=ON \
%if "%{_with_doc}" == "1"
	-DBUILD_DOCUMENTATION=ON \
%else
	-DBUILD_DOCUMENTATION=OFF \
%endif
	-DBUILD_OSG_WRAPPER=ON \
	-DBUILD_OSG_APPLICATIONS=ON \
	-DCMAKE_BUILD_TYPE=Release \
	-DDYNAMIC_OPENSCENEGRAPH=ON \
	-DDYNAMIC_OPENTHREADS=ON

%__make %{?_smp_mflags}

%install
%makeinstall

%__install -dm 755 %{buildroot}%{_libdir}/pkgconfig
%__install -m 644 packaging/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig

# icon
%__install -dm 755 %{buildroot}%{_datadir}/pixmaps
%__install -m 644 %{SOURCE1} \
	%{buildroot}%{_datadir}/pixmaps

# menu-entry
%__install -dm 755 %{buildroot}%{_datadir}/applications
%__cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Type=Application
Name=OpenSceneGraph Viewer
GenericName=OpenSceneGraph Viewer
Comment=The OpenSceneGraph - a cross platform graphics toolkit
Exec=osgviewer
Icon=%{name}
Encoding=UTF-8
Categories=X-MandrivaLinux-Multimedia-Graphics;
EOF

%clean
[ -d "%{buildroot}" -a "%{buildroot}" != "" ] && %__rm -rf "%{buildroot}"

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%post -n %{_lib}OpenThreads -p /sbin/ldconfig
%postun -n %{_lib}OpenThreads -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS.txt LICENSE.txt NEWS.txt README.txt ChangeLog
%{_bindir}/osgarchive
%{_bindir}/osgconv
%{_bindir}/osgversion
%{_bindir}/osgviewer*
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/applications/%{name}.desktop

%files plugins
%defattr(-,root,root)
%dir %{_libdir}/osgPlugins-%{version}
%{_libdir}/osgPlugins-%{version}/*

%files examples
%defattr(-,root,root)
%exclude %{_bindir}/osgarchive
%exclude %{_bindir}/osgconv
%exclude %{_bindir}/osgversion
%exclude %{_bindir}/osgviewer*
%{_bindir}/*

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libosg.so.*
%{_libdir}/libosgAnimation.so.*
%{_libdir}/libosgDB.so.*
%{_libdir}/libosgFX.so.*
%{_libdir}/libosgGA.so.*
%{_libdir}/libosgManipulator.so.*
%{_libdir}/libosgParticle.so.*
%{_libdir}/libosgShadow.so.*
%{_libdir}/libosgSim.so.*
%{_libdir}/libosgTerrain.so.*
%{_libdir}/libosgText.so.*
%{_libdir}/libosgUtil.so.*
%{_libdir}/libosgVolume.so.*
%{_libdir}/libosgViewer.so.*
%{_libdir}/libosgWidget.so.*
%{_libdir}/libosgPresentation.so.*
%{_libdir}/libosgQt.so.*

%files -n %{develname}
%defattr(-,root,root)
%{_includedir}/osgQt
%dir %{_includedir}/osg
%{_includedir}/osg/*
%dir %{_includedir}/osgAnimation
%{_includedir}/osgAnimation/*
%dir %{_includedir}/osgDB
%{_includedir}/osgDB/*
%dir %{_includedir}/osgFX
%{_includedir}/osgFX/*
%dir %{_includedir}/osgGA
%{_includedir}/osgGA/*
%dir %{_includedir}/osgManipulator
%{_includedir}/osgManipulator/*
%dir %{_includedir}/osgParticle
%{_includedir}/osgParticle/*
%dir %{_includedir}/osgShadow
%{_includedir}/osgShadow/*
%dir %{_includedir}/osgSim
%{_includedir}/osgSim/*
%dir %{_includedir}/osgTerrain
%{_includedir}/osgTerrain/*
%dir %{_includedir}/osgText
%{_includedir}/osgText/*
%dir %{_includedir}/osgUtil
%{_includedir}/osgUtil/*
%dir %{_includedir}/osgViewer
%{_includedir}/osgViewer/*
%dir %{_includedir}/osgVolume
%{_includedir}/osgVolume/*
%dir %{_includedir}/osgWidget
%{_includedir}/osgWidget/*
%{_includedir}/osgPresentation/Export
%{_includedir}/osgPresentation/AnimationMaterial
%{_includedir}/osgPresentation/CompileSlideCallback
%{_includedir}/osgPresentation/PickEventHandler
%{_includedir}/osgPresentation/SlideEventHandler
%{_includedir}/osgPresentation/SlideShowConstructor
%{_libdir}/pkgconfig/openscenegraph.pc
%{_libdir}/pkgconfig/openscenegraph-osg.pc
%{_libdir}/pkgconfig/openscenegraph-osgAnimation.pc
%{_libdir}/pkgconfig/openscenegraph-osgDB.pc
%{_libdir}/pkgconfig/openscenegraph-osgFX.pc
%{_libdir}/pkgconfig/openscenegraph-osgGA.pc
%{_libdir}/pkgconfig/openscenegraph-osgManipulator.pc
%{_libdir}/pkgconfig/openscenegraph-osgParticle.pc
%{_libdir}/pkgconfig/openscenegraph-osgShadow.pc
%{_libdir}/pkgconfig/openscenegraph-osgSim.pc
%{_libdir}/pkgconfig/openscenegraph-osgTerrain.pc
%{_libdir}/pkgconfig/openscenegraph-osgText.pc
%{_libdir}/pkgconfig/openscenegraph-osgUtil.pc
%{_libdir}/pkgconfig/openscenegraph-osgViewer.pc
%{_libdir}/pkgconfig/openscenegraph-osgVolume.pc
%{_libdir}/pkgconfig/openscenegraph-osgWidget.pc
%{_libdir}/pkgconfig/openscenegraph-osgQt.pc
%{_libdir}/libosg.so
%{_libdir}/libosgAnimation.so
%{_libdir}/libosgDB.so
%{_libdir}/libosgFX.so
%{_libdir}/libosgGA.so
%{_libdir}/libosgManipulator.so
%{_libdir}/libosgParticle.so
%{_libdir}/libosgShadow.so
%{_libdir}/libosgSim.so
%{_libdir}/libosgTerrain.so
%{_libdir}/libosgText.so
%{_libdir}/libosgUtil.so
%{_libdir}/libosgViewer.so
%{_libdir}/libosgVolume.so
%{_libdir}/libosgWidget.so
%{_libdir}/libosgPresentation.so
%{_libdir}/libosgQt.so

%files -n %{_lib}OpenThreads
%defattr(-,root,root)
%{_libdir}/libOpenThreads.so.*
%{_libdir}/libOpenThreads.so

%files -n %{_lib}OpenThreads-devel
%defattr(-,root,root)
%dir %{_includedir}/OpenThreads
%{_includedir}/OpenThreads/*
%{_libdir}/pkgconfig/openthreads.pc
%{_includedir}/osgPresentation/KeyEventHandler
%{_includedir}/osgPresentation/PropertyManager
%{_includedir}/osgPresentation/Timeout


%changelog
* Tue Nov 18 2014 bb <bb> 3.2.1-2pclos2014
- rebuild new ffmpeg 2.4

* Fri Oct 11 2013 bb <bb> 3.2.0-1pclos2013
- 3.2.0

* Tue Sep 24 2013 bb <bb> 3.0.1-3pclos2013
- rebuild with new libjpeg

